LIBRARIAN=ilibr
OCCAM=oc
LINK=ilink
CONFIG=icconf
OCONFIG=occonf
COLLECT=icollect
CC=icc
DELETE=del
LIBOPT=
OCCOPT=
LINKOPT=
CONFOPT=
OCONFOPT=
COLLECTOPT=
COPT=


##### IMAKEF CUT #####

occam2.rah: occam2.cah 
	$(COLLECT) occam2.cah /t /k  /o occam2.rah $(COLLECTOPT)

occam2.cah: occam2.lah occam2.tah 
	$(LINK) /f occam2.lah /ta /h /y /o occam2.cah $(LINKOPT)

occam2.tah: occam2.occ d:\d7205\libs\streamio.inc d:\d7205\libs\hostio.inc \
	    compilr.tah fileread.tah linksc.tah interface.tah extract.tah \
	    export.tah filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc \
	    tds1hdr.inc tds3hdr.inc interhdr.inc environ.inc envir.tah \
	    rtlhdr.inc fronthdr.inc reinit.tah conhdr.inc logical.tah \
	    d:\d7205\libs\string.lib d:\d7205\libs\string.liu \
	    d:\d7205\libs\convert.lib canuse.tah subsyst.tah compsupp.lib \
	    pbottom.occ parmfold.occ parmdesc.occ dolink.occ libval.occ \
	    runcomp.occ libchk.occ botbody.occ extrunit.occ loadnetw.occ \
	    domake.tah ndolist.tah compinfo.tah nsearch.occ 
	$(OCCAM) occam2 /ta /h /y /o occam2.tah $(OCCOPT)

compilr.tah: compilr.occ interhdr.inc fronthdr.inc namestor.tah lexer.tah \
	     syntax.tah struct.tah trans.tah bind.tah \
	     encode1.tah report.tah #type.tah genact.tah
	$(OCCAM) compilr /ta /h /y /o compilr.tah $(OCCOPT)

namestor.tah: namestor.occ interhdr.inc fronthdr.inc 
	$(OCCAM) namestor /ta /h /y /o namestor.tah $(OCCOPT)

lexer.tah: lexer.occ interhdr.inc fronthdr.inc errors.tah predefs.tah \
	   realin.tah 
	$(OCCAM) lexer /ta /h /y /o lexer.tah $(OCCOPT)

errors.tah: errors.occ fronthdr.inc 
	$(OCCAM) errors /ta /h /y /o errors.tah $(OCCOPT)

predefs.tah: predefs.occ 
	$(OCCAM) predefs /ta /h /y /o predefs.tah $(OCCOPT)

realin.tah: realin.occ d:\d7205\libs\occamutl.lib 
	$(OCCAM) realin /ta /h /y /o realin.tah $(OCCOPT)

syntax.tah: syntax.occ fronthdr.inc errors.tah 
	$(OCCAM) syntax /ta /h /y /o syntax.tah $(OCCOPT)

struct.tah: struct.occ interhdr.inc fronthdr.inc errors.tah 
	$(OCCAM) struct /ta /h /y /o struct.tah $(OCCOPT)

type.tah: type.occ arithm01.occ predefs.tah interhdr.inc fronthdr.inc \
	  conhdr.inc canuse.tah errors.tah varexp.inc variab00.occ \
	  evalua00.occ debug00.occ readin00.occ consta01.occ variab02.occ \
	  suppor02.occ usage001.occ alias01.occ usage00.occ alias000.occ \
	  builde03.occ more0101.occ proc0900.occ proc1000.occ proc0800.occ \
	  some00.occ main0201.occ set00.occ 
	$(OCCAM) type /ta /h /y /o type.tah $(OCCOPT)

canuse.tah: canuse.occ interhdr.inc 
	$(OCCAM) canuse /ta /h /y /o canuse.tah $(OCCOPT)

trans.tah: trans.occ interhdr.inc fronthdr.inc errors.tah 
	$(OCCAM) trans /ta /h /y /o trans.tah $(OCCOPT)

genact.tah: genact.occ interhdr.inc fronthdr.inc bindhdr.inc transhdr.inc \
	    errors.tah predefs.tah conhdr.inc build02.occ gen08.occ gen09.occ \
	    gen10.occ buildexp.occ libs02.occ main07.occ 
	$(OCCAM) genact /ta /h /y /o genact.tah $(OCCOPT)

bind.tah: bind.occ interhdr.inc fronthdr.inc bindhdr.inc errors.tah rtlhdr.inc \
	  predefs.tah conhdr.inc support.occ main.occ 
	$(OCCAM) bind /ta /h /y /o bind.tah $(OCCOPT)

encode1.tah: encode1.occ interhdr.inc fronthdr.inc bindhdr.inc transhdr.inc \
	     errors.tah rtlhdr.inc conhdr.inc 
	$(OCCAM) encode1 /ta /h /y /o encode1.tah $(OCCOPT)

report.tah: report.occ interhdr.inc fronthdr.inc bindhdr.inc rtlhdr.inc 
	$(OCCAM) report /ta /h /y /o report.tah $(OCCOPT)

fileread.tah: fileread.occ filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc \
	      tds1hdr.inc tds3hdr.inc interhdr.inc d:\d7205\libs\streamio.inc \
	      d:\d7205\libs\hostio.inc environ.inc fronthdr.inc conhdr.inc \
	      canuse.tah envir.tah 
	$(OCCAM) fileread /ta /h /y /o fileread.tah $(OCCOPT)

envir.tah: envir.occ environ.inc d:\d7205\libs\streamio.inc filerhdr.inc \
	   krnlhdr.inc userhdr.inc tdshdr.inc tds1hdr.inc predefs.tah \
	   d:\d7205\libs\hostio.inc d:\d7205\libs\convert.lib \
	   d:\d7205\libs\hostio.lib d:\d7205\libs\hostio.liu 
	$(OCCAM) envir /ta /h /y /o envir.tah $(OCCOPT)

linksc.tah: linksc.occ filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc \
	    tds1hdr.inc interhdr.inc d:\d7205\libs\streamio.inc \
	    d:\d7205\libs\hostio.inc environ.inc fronthdr.inc conhdr.inc \
	    canuse.tah envir.tah stknam.occ linksupp.occ linkproc.occ \
	    linkmain.occ 
	$(OCCAM) linksc /ta /h /y /o linksc.tah $(OCCOPT)

interface.tah: interface.occ filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc \
	       tds1hdr.inc interhdr.inc 
	$(OCCAM) interface /ta /h /y /o interface.tah $(OCCOPT)

extract.tah: extract.occ d:\d7205\libs\streamio.inc d:\d7205\libs\hostio.inc \
	     filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc tds1hdr.inc \
	     interhdr.inc environ.inc fronthdr.inc conhdr.inc envir.tah \
	     compsupp.lib loadta02.occ loadtr02.occ loadpr02.occ 
	$(OCCAM) extract /ta /h /y /o extract.tah $(OCCOPT)

compsupp.lib: compsupp.lbb strin.tah strout.tah linker.tah prune.tah \
	      firstpro.tah 
	$(LIBRARIAN) /f compsupp.lbb  /o compsupp.lib $(LIBOPT)

strin.tah: strin.occ filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc \
	   tds1hdr.inc interhdr.inc logical.tah readfstr.occ 
	$(OCCAM) strin /ta /h /y /o strin.tah $(OCCOPT)

logical.tah: logical.occ userhdr.inc krnlhdr.inc filerhdr.inc tdshdr.inc \
	     interhdr.inc d:\d7205\libs\hostio.inc d:\d7205\libs\streamio.inc \
	     environ.inc envir.tah 
	$(OCCAM) logical /ta /h /y /o logical.tah $(OCCOPT)

strout.tah: strout.occ filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc \
	    tds1hdr.inc interhdr.inc logical.tah write.occ 
	$(OCCAM) strout /ta /h /y /o strout.tah $(OCCOPT)

linker.tah: linker.occ filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc \
	    tds1hdr.inc interhdr.inc d:\d7205\libs\hostio.inc \
	    d:\d7205\libs\streamio.inc environ.inc envir.tah 
	$(OCCAM) linker /ta /h /y /o linker.tah $(OCCOPT)

prune.tah: prune.occ fronthdr.inc conhdr.inc 
	$(OCCAM) prune /ta /h /y /o prune.tah $(OCCOPT)

firstpro.tah: firstpro.occ d:\d7205\libs\hostio.inc d:\d7205\libs\streamio.inc \
	      environ.inc envir.tah 
	$(OCCAM) firstpro /ta /h /y /o firstpro.tah $(OCCOPT)

export.tah: export.occ filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc \
	    tds1hdr.inc interhdr.inc d:\d7205\libs\streamio.inc \
	    d:\d7205\libs\hostio.inc environ.inc envir.tah 
	$(OCCAM) export /ta /h /y /o export.tah $(OCCOPT)

reinit.tah: reinit.occ 
	$(OCCAM) reinit /ta /h /y /o reinit.tah $(OCCOPT)

subsyst.tah: subsyst.occ d:\d7205\libs\streamio.inc d:\d7205\libs\hostio.inc 
	$(OCCAM) subsyst /ta /h /y /o subsyst.tah $(OCCOPT)

domake.tah: domake.occ filerhdr.inc krnlhdr.inc userhdr.inc tdshdr.inc \
	    tds1hdr.inc d:\d7205\libs\streamio.inc d:\d7205\libs\hostio.inc \
	    environ.inc envir.tah 
	$(OCCAM) domake /ta /h /y /o domake.tah $(OCCOPT)

ndolist.tah: ndolist.occ d:\d7205\libs\streamio.inc userhdr.inc filerhdr.inc \
	     krnlhdr.inc d:\d7205\libs\hostio.inc d:\d7205\libs\hostio.lib \
	     d:\d7205\libs\hostio.liu d:\d7205\libs\convert.lib \
	     \gnu\oc\tds3\userio.lib tdshdr.inc environ.inc envir.tah \
	     \gnu\oc\tds3\interf.lib 
	$(OCCAM) ndolist /ta /h /y /o ndolist.tah $(OCCOPT)

compinfo.tah: compinfo.occ d:\d7205\libs\hostio.inc d:\d7205\libs\streamio.inc \
	      filerhdr.inc krnlhdr.inc tdshdr.inc interhdr.inc environ.inc \
	      envir.tah d:\d7205\libs\string.lib d:\d7205\libs\string.liu \
	      d:\d7205\libs\convert.lib compsupp.lib memmap.tah codinf2.occ \
	      codinf3.occ 
	$(OCCAM) compinfo /ta /h /y /o compinfo.tah $(OCCOPT)

memmap.tah: memmap.occ d:\d7205\libs\hostio.inc d:\d7205\libs\streamio.inc \
	    filerhdr.inc krnlhdr.inc tdshdr.inc interhdr.inc environ.inc \
	    envir.tah d:\d7205\libs\string.lib d:\d7205\libs\string.liu \
	    d:\d7205\libs\convert.lib compsupp.lib inferr.occ infstk.occ \
	    inftree.occ infout.occ 
	$(OCCAM) memmap /ta /h /y /o memmap.tah $(OCCOPT)

